This is another bungalow example with a shed dormer facing the street. The gable-ended porch is unusual. Typically, the main roof extends over the porch.

The main roof here is steeply pitched. I call this style the "high bungalow." Thought experiment: redesign this home so that the main roof extends over the porch.

The tapered columns (the white part) supporting the porch roof are a common Craftsman treatment. The child-proofing appears to be a later addition.

Florida, NY, c. 1910.

Craftsman bungalow with gable-ended porch


Edges to Rubies The Complete SketchUp Tutorial


The apartments floor

Chapter 4—The Apartment's Floor

Administrative note: Do you still use that Large Tool Set toolbar? I've turned mine off.

Beginning here and continuing through Chapter 8 we'll be modeling the second-floor apartment. You'll meet every challenge that you'd face if you were modeling a house. The floor is the easiest part, so we'll fold a couple miscellaneous bits into this chapter, beginning with the Qrotate tool.

The Qrotate Tool

You've used the Rectangle tool long enough to know its keyboard shortcut. In fact, every letter in Rotate is taken: Rectangle, Orbit, Tape measure, Arc and Eraser. What to do? Google decided on Q, which you probably guessed from my funny spelling: Qrotate.

What does Qrotate do? It rotates things. Why do you need it?

Carriage doors along wrong axis 

If you haven't done so yet, open "ground_floor.skp". File/Import... your carriage doors. We need to rotate the doors 90 degrees to fit them into the doorways.

Before we dive into the Qrotate tool, let's look at how it infers an orientation from the surface it finds itself on.

Rotate tool on axis Rotate tool on axis Rotate tool on axis Rotate tool on axis

If your Qrotate tool is somewhere out in space, with no surface around, it guesses that you want to rotate around the blue axis (on the red/green plane). If you have an axis of rotation that you like, hold the shift key down to keep it from changing. This lets you put the Qrotate cursor on a point or an edge but stay in control of the axis of rotation.

Qrotate is a three-click tool. Your first click specifies the center of the rotation. Your second click picks a point that follows your rotate cursor. (Picture a line from cursor through center of rotation. Your second click point will be on that line.) The third click says "I'm done".

Important! Qrotate is just like Move. If nothing is selected, Qrotate autoselects whatever it passes over. If anything is already selected, however, that is the thing that will be rotated regardless of your first click.

Qrotate is a six-step tool:

  1. Select the thing to rotate
  2. Set the axis of rotation, hold with shift
  3. Click the center point
  4. Click the "follow cursor" point
  5. Rotate
  6. Click "I'm done."

Your rotations will be in 15 degree increments, by default. This is usually OK. You can type and your orders will be obeyed. You can type "37.875" (the approximate slope of a 7:9 stairway, in degrees or you can type "7:9" for a more exact angle. The VCB will show your choice.

Try this: create a cube. Give it six different face colors. Qrotate it around points on the ground plane, so that it stays on the ground plane. For your first rotation, deliberately forget to make it a group. It's a disaster, but pressing Esc before the third click rescues you.

I've rotated a cube here:

Die showing 1 Die showing 2 Die showing 3

Die showing 4 Die showing 5 Die showing 6

The trick with the die is that 3 and 4 are on opposite faces. That means you have to do two separate rotations if you want to stay on the ground plane.

Your center point and your rotation point are usually in the object being rotated. But they don't need to be.

Your first click sets the center point of the rotation. It does not select the object you click! You must use the Select tool before you use the Qrotate tool.

Like the Move tool, you can tap Ctrl (Option) to make a copy or copies. You type an angle, Enter, number of copies (e.g., "6x"), Enter.

Let's think outside the right-angled architectural box. Here's an oval column, rotated with copy, 15 degrees around the origin, six times:

Quarter circle of oval columns
Oval columns? Simple. Circle, Scale, PushPull. Try it!

Installing the Carriage Doors

Now let's return to the right-angled architectural box and install those carriage doors. Open "ground_floor.skp". File/Import... the carriage doors, if you haven't already done so.

Before we get started, examine your doors. They have one decorated surface (outside) and one plain surface (inside). You will not be happy if you rotate the wrong way.

Now we start. Zoom in so the top of the doors is a large surface. If you can still see the whole door you're not nearly close enough. Zoom way in. With the door component selected, place your Qrotate tool on top. If it is not blue, place it on the floor next to the doors. Lock the orientation by holding a shift key down. Click somewhere (anywhere) on the top for a center, somewhere else (anywhere else) for a rotation point and then rotate. When you are 90 degrees (check that the VCB says "90.0"—type "90" if it doesn't) click "I'm done." and immediately go back to the Select tool.

Two precise moves, the first with copy mode selected, will put those doors into their doorways. After getting them in their doorways, I moved my doors back a couple inches. Suit yourself.

Handsome ground floor

Doors such as these are available today, complete with automatic openers. They're very expensive. Here in cyberspace, that doesn't matter.

Carriage doors, open 45 degrees.  

Wouldn't it be great if you could open and shut these doors?

Carriage doors, open 90 degrees.  

You'd rotate each door 90/number_of_frames, opening them fully in, say, 3 seconds.

Carriage doors, open with 1913 Model T.  

Then you could drive something like this 1913 Model T Ford (courtesy, the 3D Warehouse) into your carriage house garage.

We'd just need to convert the doors, now component instances, into movable component instances. You'll see in Chapter 16 that this is easier than you might guess.

Drawing the Apartment Floor

The subject matter of this chapter, the apartment floor, is dead simple (giving us a chance to do other things).

Here's a decision. To make the apartment floor, you can use the Rectangle tool (plus a Move) or you can use the Ruby Console. For a single use, the Rectangle tool is simpler. Using an editor to create your Ruby Console command lets you repeat the command as often as you need. Only the first time requires some work. Of course you can save the result either way and then File/Import... it.

"Indecision may, or may not, be part of my problem." Jimmy Buffett

Let's do both.

Ctrl+N. Rectangle from the origin to 28'4, 25'4. Select, double-click face. Move origin up (on blue axis) 9'4. That was pretty simple. File/Save As... apt_flr. (Note: I don't abbreviate file names that way, unless I want to remind myself that this is not finished geometry; it's for use during construction.)

Rubby Console? Ctrl+N. Window/Ruby Console. f = Sketchup.active_model.entities.add_face [0,0,112], [304,0,112], [304,340,112], [0,340,112] File/Save As... apt_flr.

It's tough to make a strong argument that one is easier than the other. But they are different. Your Rectangle floor faces down. Your Ruby Console floor faces up. (If your floor were drawn clockwise, it would face down. This is a feature allowing extremely cryptic code. Code should be obvious.)

Apartment floor 

Whichever way you created your rectangle, PushPull down 12". oFFset inside 8" (for the outside walls). Lay, sand and varnish a nice hardwood floor. (I chose Wood_Floor_Light.) File/Save As... "apartment_floor.skp".

Cutting the Stairway

No stairwell in floor 

File/Import... ground_floor.skp. Click the origin to precisely position the ground floor. You can clearly see your bannister popping up where it wishes you had a stairwell.

Xray view of ground floor through apartment floor 

In practice, I don't use the X-ray view often. Others use it constantly. You? View/Face Style/X-ray. It's there if you want it. Does this one clarify the problem for you?

We need to cut a hole for the stairway. What is not clear is exactly where. Our stairs are 30 inches wide, just inside the outside wall, which tells us where to cut on the red axis. But on the green axis?

Plan view of ground floor stairway 

Open "ground_floor.skp". Camera/Standard Views/Top. This is very similar to a traditional 2d plan view. Look closely and you see that it's a 3d view from directly overhead. Z for zoom and double-click the center of the stairs. Run a Tape measure from the far end of the stairs to the outside of the wall. Add the length of the "nick" wall, in the green axis direction. I get 15'1/2" plus 3', or 18' 1/2".

These American units are certainly a mess compared to just using millimeters. You may find it helpful to know that you can type fractions of an inch in the same manner the VCB shows fractions. "3.5" is the same as "3 1/2". Now let's double-check the 18' 1/2" measurement.

Double checking the measurement 

This time, zoom in on the top of the stairs. Tape measure from the top stair down to the outside wall, being careful to stay on the red axis. (Either Camera/Standard Views/Left, then Z double-click stair top, or Orbit until you are looking straight down the front edge of the top step.) You get a guide point. Measure from the guide point to the far end of the left wall. I get 7' 3 1/2".

Adding 7' 3 1/2" to 18' 1/2" you get 25'4", exactly. We now know where the stairs end.

The only thing you don't know is where to start the stairwell cut. The shorter the stairwell, the more space in the apartment. Less really is more, here. On the other hand, too short and people will bang their heads on the climb, or your building inspector will bang your head and tell you that your stairway doesn't comply with the local code.

Drawing construction guides to size the stairwell To decide for myself, I opened "stairway.skp", drew a line for the bottom side of the floor and Tape measured out some construction guides meeting the edges of the lower steps. By measuring, I found that the third step was 6'7" below the ceiling. Reasoning that anyone over 6'7" tall was used to ducking, my stairwell was to be the length of the stairway, minus the first two steps: 118 1/2" long.

Cutting the stairwell 

A word about our stairway. The top step has a run of 10.5 inches. You could fix this. Since the other steps are fine, you don't want to edit them. You'd need to explode the top step and put it back together as a group before you edit. And after that much trouble your model won't be one bit better than mine, which just jams the stairway an inch and a half into the floor. With that information, lay out construction guides; Rectangle and PushPull the stairwell. In the next paragraph I'll give you my exact layout, but try it first on your own.

I laid out the red axis guide 44 inches in from the outside edge. 36" from the inside wall edge is fine, too. The stairwell end guide was 7' 5" from the outside of the far wall. 17' 11" from the outside of the near wall is fine, too. The last guide is 117" from the previous.

One more detail to clear up. First, you should know that the Bucket can pick up a color from your model. You don't need to go back to the Materials window. B for the bucket. Move it over the color you want to pick up. Alt turns your cursor into an eye dropper. Click picks up the color.

Painting the stairwell 

If you look above, you see that the carpenter who laid the floor came back and added flooring to your stairwell. No problem. Call the painters and tell them to paint over the flooring. Use the eye dropper technique.

Don't forget that you have four faces to paint, not just the two visible here.

Finally, I want the outside of the floor (it's the outside of the carriage house, too) a woody brown. I used Color_C18. While you've got the painters, get them to do this. (You'll alternate between Orbit and Bucket to get all four sides—a great example of how the keyboard shortcuts save time.)

Adding Text

I don't like adding text to my models. If there's something not clear, make it clear! Don't use text as a substitute for model clarity. That said, let's add some text. We'll clarify that the stairwell is a stairwell.

Adding stairwell text 

Use Tools/Text (there's no keyboard shortcut). This is a three-click tool. Click once on the item you are clarifying and click again where you want your text. Type your text and click again for "I'm done".

Orbit around, text stays constant 

Try orbiting around. Your text keeps pointing at the stairwell. It stays upright. SketchUp does its best to keep it where you put it.

This is altogether a very nice job on SketchUp's part. Still, I'm happier when I delete the text. Select tool; click the text; Delete.

Adding 3D Text

Here's a whole other thing. You want to add your store logo in front of your store? 3d text is actually part of your geometry. We don't need it here, but we can try it just the same.

Click Tools/3D Text (again, no keyboard shortcut). You get a dialog inviting you to enter your text, set font, font size, extrusion depth, etc. The example below uses 24" tall letters, extruded 6".

Where another dialog ends with an "OK" button, this ends with "Place". When you place your text into your model, it's usually in the wrong place and at the wrong orientation. Move it around until you find the right orientation and place it. After you initially place it, use the Move tool to get it where you really want it.

Your job: do something like the image above. If your name is Amalie, "Amalie Rules!" would be a good choice. Warning: not every font makes for readable 3d text.

Working in Layers

Layers are a horror story if you don't use them correctly. They are a blessing if you get them right. One short paragraph on how to get them wrong, and then we'll move on.

Wrong: layers must include only complete groups or components. If you put some geometry, not grouped, into one layer and other geometry into other layers you will almost immediately find yourself with a face in one layer partly defined by an edge in another layer. This is a prescription for disaster. If you want to prove this true, ignore this advice. (Guess how I know this.)

Right: import complete layers into the final model. File/Import... automatically makes a component of the complete import. You cannot get this wrong. You will never have "edge in other layer" conflicts. You will love your layers.

Not at all by coincidence, the three levels we've built this far make excellent layers. Begin in the basement.

Basements Layers window

First, turn on the Layers window and the Entity Info window. (I never turn mine off.) Click the "+", top-left in Layers. You'll get a new layer, imaginatively named "Layer1". Happily, it's selected so you can immediately type your own name. For these layers I always use the same name as the file: "basement" is good here.

Note that Visible is checked for both Layer0 and basement. Now click your SketchUp window. (Don't forget that these additional windows are windows in their own right. You need to click back to SketchUp to give it focus.) Press Ctrl+A. The Entity Info window will tell you about the entities you have selected, and it will tell you what layer they are in.

Basements Entity Info window

Unless you've been playing with layers on your own, all your entities are in Layer0. (The Layer: dropdown is blank if you have selected entities in multiple layers.) Press the dropdown arrow and select "basement". All your entities are now in the "basement" layer. To check this, click the "Visible" box beside "basement" in the Layers window. Your model disappears! (You put every entity into the "basement" layer and then said, "Don't display basement." Disappearing is good.) Click the "Visible" box again and your model reappears. Life is good.

Follow this cookbook for every model you create just before you save the completed model:

  1. Create a layer, same name as model, in Layers
  2. Select All in model
  3. Move all into the new layer, in Entity Info
  4. Click Visible off and on to double-check, in Layers
Open "ground_floor.skp". Follow the cookbook. Open "apartment_floor.skp". Follow the cookbook. Now let's use these layers.

Oddly enough, the final model, "carriage_house" that pulls everything together is really a throwaway. Let's build one now. File/New (or Ctrl+N).

File/Import... "basement", then "ground_floor" and last, "apartment_floor". Each import is to the origin and everything is precisely aligned. Now check your Layers window. Each file has become its own layer. Try clicking layers' Visible boxes.

First assembly of carriage house

Got it? Good!

The Outliner

If you've just built a model you probably have a good idea of its contents. A week later? A month later? The Outliner window will let you take a look.
Outliner windows, various expansions

On the top left, you see that the ground_floor component (the four black rectangles tell you that it's a component) contains two carriage_doors components and a stairway component. Below that, you see that the carriage_doors component is built from two carriage_door components. On the right you see that mindlessly expanding components may not always be helpful.

The right-pointing arrow at the top of the box gives you more options, including the option to turn off sorting by name. If you do so you get the pieces in the order you added them. This may be exactly what we want.

I've no idea what the Filter: box is about. I've never had so many things that I wanted to filter them.

Next, we'll create the apartment's outside walls layer.


Carriage house ground floor. View of apartment contents. The apartments outside walls.